#include <stdio.h>
#include <string.h>
#define TAM         50

struct ender {
  char *nome;
  unsigned int idade;
  char *email;
};
typedef struct ender ENDERECO;

ENDERECO leItem ()
{
  char buffer[TAM];
  ENDERECO item;
  /* Obtem os dados de um item da agenda */
  printf("NOME: ");    fgets(buffer, TAM, stdin);
  item.nome = strdup (buffer);   /* cria uma copia de buffer */
  printf("IDADE: ");   scanf ("%d", &item.idade); getchar();
  printf("E-MAIL: ");  fgets(buffer, TAM, stdin);
  item.email = strdup (buffer);   /* cria uma copia de buffer */
  return item;
}

main ()
{
  ENDERECO *agenda, *ragenda;
  char *arquivo = "arq.db";
  int nitens;
  FILE *fp;
  fp = fopen (arquivo, "w+");
  if (fp == NULL)
    printf("Erro ao abrir arquivo %s\n", arquivo);
  else {
    agenda = (ENDERECO *) calloc (0, sizeof(ENDERECO));
    nitens = 0;
    do {
      agenda = (ENDERECO *) realloc (agenda,
				     (nitens + 1) * sizeof(ENDERECO));
      if (agenda)
	agenda[nitens] = leItem();
    } while (agenda && strlen(agenda[nitens++].nome));
    printf("\n\nGravando agenda no arquivo\n\n");
    fwrite(agenda, sizeof(ENDERECO), nitens-1, fp);
    fflush(fp);
    rewind(fp);
    printf("\n\nLendo agenda do arquivo\n\n");
    ragenda = (ENDERECO *) calloc (nitens-1, sizeof(ENDERECO));
    fread(ragenda, sizeof(ENDERECO), nitens, fp);
    for ( ; strlen(ragenda->nome); ragenda++) {
      printf("NOME: %s\n", ragenda->nome);
      printf("E-MAIL: %s\n", ragenda->email);
      printf("IDADE: %d\n", ragenda->idade);
    }
    fclose(fp);     /* fecha arquivo */
  }  /* FIM (fp == NULL) */
}
